###
### Account Services Manager
###
########################################################################
### This program is free software; you can redistribute it and/or
### modify it under the terms of the GNU General Public License
### as published by the Free Software Foundation; either version 2
### of the License, or (at your option) any later version.
###
### This program is distributed in the hope that it will be useful,
### but WITHOUT ANY WARRANTY; without even the implied warranty of
### MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
### GNU General Public License for more details.
###
### You should have received a copy of the GNU General Public License
### along with this program; if not, write to the Free Software
### Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
########################################################################

# Declare global variables.
use vars qw(%HTTP_Args %Global_Config %modules $module);
do '../lib/module-vars.ph';

if(!require('../lib/main.pl'))
{
    print "Content-type: text/html\n\n";
    print "FATAL ERROR: Could not load the main library: $@";
}

require "$BaseDir/lib/auth.pl" || FatalError("An error occured loading the auth library: $@");
SendHeaders();

# Load the module.
$module = $HTTP_Args{'module'};
$MODULE::Path = sprintf("%s/modules/%s", $BaseDir, API::BaseDir($modules{$module}[0])) if(exists $modules{$module});
if(!$module)
{
    # Use default module.
    $module = "default";
    eval{require "$BaseDir/modules/default/default.asm";} || FatalError("Could not load the required module: $@");
}
else
{
    # Load the module.
    if(exists $modules{$module})
    {
        $MODULE::Title = $modules{$module}[1];
        eval{require "$BaseDir/modules/$modules{$module}[0]";} || FatalError("Could not load the required module: $@");
    }
    else
    {
        FatalError("Module '$module' not found.");
    }
}

# Finally execute the module!
ExecuteModule();
