###
### Account Services Manager - Authentication Subsystem Core
###

package AUTH;

use vars qw($User);
my @info, $logintime, $rnd_hash;

($User, $logintime, $rnd_hash) = split(/`:`/, API::GetCookie('asm'));
$User      = $1 if($User      =~ /^([^<]*)$/);
$logintime = $1 if($logintime =~ /^([^<]*)$/);
$rnd_hash  = $1 if($rnd_hash  =~ /^([^<]*)$/);

if($User)
{
    SetUserConf();
    # If the session doesn't exist, just erase the cookie and bounce them to the login page.
    if(!GetSessionInfo())
    {
        print "Set-Cookie: asm=; expires=-1\n";
        API::LogError("Invalid session in use - terminating login for $User.");
        Login("Invalid session");
    }
    if($info[0] eq $ENV{'REMOTE_ADDR'} && $info[1] eq $ENV{'REMOTE_HOST'} && $info[2] eq $rnd_hash) {
        &::EvalConfVars();
        TouchSessionLock();
    } else {
        API::LogError("Session $User.$logintime provided invalid authentication tokens.");
        Login('Invalid authentication tokens.');
    }
} else {
    Login();
}

# We don't need these anymore...
undef @info, $logintime, $rnd_hash;

# Send the redirect header to the web browser so they can login.
sub Login
{
    print "Location: /login.cgi?error=$_[0]\n\n";
    exit;
}

# Get the specs for the session to check for when authenticating.
sub GetSessionInfo
{
    open(SESSION, "$::BaseDir/lock/$User.$logintime") || return 0;
    @info = split(/\n/, join('', <SESSION>));
    close SESSION;

    return 1;
}

# Setup the global user configuration.
sub SetUserConf
{
    my @lines, $name, $value;

    open(CONF, "$::BaseDir/users/$User") || &::FatalError("Failed opening user config file for $User: $!");
    @lines = split(/\n/, join('', <CONF>));
    close CONF;

    foreach(@lines)
    {
        ($name, $value) = split(/: /);
        $value =~ /^([^<]*)$/;
        $value = $1;
        $::UserConf{$name} = $value;
    }
}

sub TouchSessionLock
{
    open(LOCK, ">$::BaseDir/lock/$User.$logintime");
    foreach(@info) {
        print LOCK "$_\n";
    }
    close LOCK;
}

1;
