###
### Account Services Manager - Authentication Module
###

# In this module, we check if the encoded password is already loaded.
# This will make our job easier since we can utilize the API.

use vars qw($IsUnixPassword);
$IsUnixPassword = 0;

sub GetPassword
{
    if(exists $::UserConf{'Passwd'}) {
        return $::UserConf{'Passwd'};
    }
    else {
        my $User = shift;
        open(AUTH, "$::BaseDir/users/$User");
        my @buffer = split("\n", join('', <AUTH>));
        close AUTH;
        my @tmp;
        foreach(@buffer) {
            @tmp = split(': ', $_);
            return $tmp[1] if($tmp[0] eq 'Passwd');
        }
    }

    &::FatalError("Unable to read encoded password from file.");
}

sub ChangePassword
{
    if(exists $::UserConf{'Passwd'}) {
        $::UserConf{'Passwd'} = crypt($_[0], RandomSalt());
        API::UpdateUserConf();
    }
    else {
        my $User = shift;
        my $new_passwd = crypt(shift, RandomSalt());
        open(AUTH, "$::BaseDir/users/$User");
        my @buffer = split("\n", join('', <AUTH>));
        close AUTH;
        my)@tmp, $i);
        for($i = 0; $i < $#buffer; $i++) {
            @tmp = split(': ', $buffer[$i]);
            if($tmp[0] eq 'Passwd') {
                $buffer[$i] = "Passwd: $new_passwd";
            }
        }
        open(AUTH, ">$::BaseDir/users/$User");
        foreach(@buffer) {
            print AUTH "$_\n";
        }
        close AUTH;
    }
}

# This one's simple, we take a username and password and check it.
sub CheckPassword
{
    my($username, $password) = @_;

    return 0 unless(-e "$::BaseDir/users/$username");

    my $correct_passwd = GetPassword($username);
    if(crypt($password, $correct_passwd) eq $correct_passwd) {
        return 1;
    }
}

1;
