#
# Account Services Manager - Custom Error Documents Module
#

my $filename = "$Global_Config{'DocumentRoot'}[1]/$Global_Config{'AccessFileName'}[1]";

sub Main
{
    my $error_code = $HTTP_Args{'error_code'};
    my $action     = $HTTP_Args{'action'};
    my $document   = $HTTP_Args{'document'};

    if($action eq 'set-doc') {
        if($error_code == 400 || $error_code == 401 || $error_code == 403 || $error_code == 404 || $error_code == 500) {
            if($document) {
                open(HTACCESS, $filename);
                my $buffer = join('', <HTACCESS>);
                close(HTACCESS);

                if($buffer !~ s/ErrorDocument $error_code .*\n/ErrorDocument $error_code $document\n/) {
                    if($buffer !~ /\n$/) {
                        $buffer .= "\n";
                    }
                    $buffer .= "ErrorDocument $error_code $document\n";
                }

                open(HTACCESS, ">$filename");
                print HTACCESS $buffer;
                close HTACCESS;

                undef $buffer;

                my $tmp = getpwnam($AUTH::User);
                chown($filename, $tmp[2], $tmp[3]);

                print "<font face=\"verdana, arial\" size=\"2\">Document for HTTP error $error_code has been set.</font>\n";
            }
            else {
                print "<form method=\"post\" action=\"index.cgi\">\n";
                print "<input type=\"hidden\" name=\"module\" value=\"error-docs\">\n";
                print "<input type=\"hidden\" name=\"action\" value=\"set-doc\">\n";
                print "<input type=\"hidden\" name=\"error_code\" value=\"$error_code\">\n";
                print "<font face=\"verdana, arial\" size=\"2\">Enter the path to the document (i.e. /error-docs/$error_code.html) <input type=\"text\" name=\"document\" value=\"\" size=\"35\" maxlength=\"50\"></font><br>\n";
                print "<input type=\"submit\" value=\"Submit\">\n";
                print "</form>\n";
            }
        }
        else {
            print "<font face=\"verdana, arial\" size=\"2\" color=\"#FF0000\">Unsupported error code '$error_code'.</font>\n";
        }
    }
    elsif($action eq 'unset-doc') {
        open(HTACCESS, $filename);
        my $buffer = join('', <HTACCESS>);
        close(HTACCESS);

        $buffer =~ s/ErrorDocument $error_code *.\n?//i;

        open(HTACCESS, ">$filename");
        print HTACCESS $buffer;
        close HTACCESS;

        undef $buffer;

        print "<font face=\"verdana, arial\" size=\"2\">Document for HTTP error $error_code has been unset.</font>\n";
    }
    else {
        print "<p align=\"center\"><font face=\"verdana, arial\" size=\"2\">You can use this module to setup custom error pages for visitors to see when they encounter an error on your web site. Below is\n";
        print "a table listing all of the errors you can set a document for. Whatever you set as the document for an error will replace the default error page your web browser shows.</font></p>\n";
    }

    open(HTACCESS, $filename);
    my @lines = split("\n", join('', <HTACCESS>));
    close(HTACCESS);

    my %errors;
    foreach(@lines) {
        if($_ =~ /^\s*\t*ErrorDocument (\d\d\d) (.*)$/) {
            $errors{$1} = $2;
        }
    }

    print "<table border=\"1\" align=\"center\" cellpadding=\"0\" cellspacing=\"0\" width=\"98%\">\n";
    print " <tr>\n";
    print "  <td><u>Error Code</u></td>\n";
    print "  <td><u>Error Name</u></td>\n";
    print "  <td><u>Document</u></td>\n";
    print "  <td><u>Set Document</u></td>\n";
    print "  <td><u>Unset Document</u></td>\n";
    print " </tr>\n";

    print " <tr>\n";
    print "  <td>400</td>\n";
    print "  <td>Bad Request</td>\n";
    if(exists $errors{'400'} && $errors{'400'}) {
        print "  <td>$errors{'400'}</td>\n";
    }
    else {
        print "  <td align=\"center\">-</td>\n";
    }
    print "  <td><a href=\"index.cgi?module=error-docs&action=set-doc&error_code=400\">Set</a></td>\n";
    if(exists $errors{'400'} && $errors{'400'}) {
        print "  <td><a href=\"index.cgi?module=error-docs&action=unset-doc&error_code=400\">Unset</a></td>\n";
    }
    else {
        print "  <td align=\"center\">-</td>\n";
    }
    print " </tr>\n";

    print " <tr>\n";
    print "  <td>401</td>\n";
    print "  <td>Authorization Required</td>\n";
    if(exists $errors{'401'} && $errors{'401'}) {
        print "  <td>$errors{'401'}</td>\n";
    }
    else {
        print "  <td align=\"center\">-</td>\n";
    }
    print "  <td><a href=\"index.cgi?module=error-docs&action=set-doc&error_code=401\">Set</a></td>\n";
    if(exists $errors{'401'} && $errors{'401'}) { 
        print "  <td><a href=\"index.cgi?module=error-docs&action=unset-doc&error_code=401\">Unset</a></td>\n";
    }
    else {
        print "  <td align=\"center\">-</td>\n";
    }
    print " </tr>\n";

    print " <tr>\n";
    print "  <td>403</td>\n";
    print "  <td>Forbidden</td>\n";
    if(exists $errors{'403'} && $errors{'403'}) {
        print "  <td>$errors{'403'}</td>\n";
    }
    else {
        print "  <td align=\"center\">-</td>\n";
    }
    print "  <td><a href=\"index.cgi?module=error-docs&action=set-doc&error_code=403\">Set</a></td>\n";
    if(exists $errors{'403'} && $errors{'403'}) { 
        print "  <td><a href=\"index.cgi?module=error-docs&action=unset-doc&error_code=403\">Unset</a></td>\n";
    }
    else {
        print "  <td align=\"center\">-</td>\n";
    }
    print " </tr>\n";

    print " <tr>\n";
    print "  <td>404</td>\n";
    print "  <td>File Not Found</td>\n";
    if(exists $errors{'404'} && $errors{'404'}) {
        print "  <td>$errors{'404'}</td>\n";
    }
    else {
        print "  <td align=\"center\">-</td>\n";
    }
    print "  <td><a href=\"index.cgi?module=error-docs&action=set-doc&error_code=404\">Set</a></td>\n";
    if(exists $errors{'404'} && $errors{'404'}) { 
        print "  <td><a href=\"index.cgi?module=error-docs&action=unset-doc&error_code=404\">Unset</a></td>\n";
    }
    else {
        print "  <td align=\"center\">-</td>\n";
    }
    print " </tr>\n";

    print " <tr>\n";
    print "  <td>500</td>\n";
    print "  <td>Internal Server Error</td>\n";
    if(exists $errors{'500'} && $errors{'500'}) {
        print "  <td>$errors{'500'}</td>\n";
    }
    else {
        print "  <td align=\"center\">-</td>\n";
    }
    print "  <td><a href=\"index.cgi?module=error-docs&action=set-doc&error_code=500\">Set</a></td>\n";
    if(exists $errors{'500'} && $errors{'500'}) { 
        print "  <td><a href=\"index.cgi?module=error-docs&action=unset-doc&error_code=500\">Unset</a></td>\n";
    }
    else {
        print "  <td align=\"center\">-</td>\n";
    }
    print " </tr>\n";

    print "</table>\n";
}

1;
