###
### Account Services Manager - Update Password module
###

# Set the display title.
$MODULE::Title = "Update Password";

# Some JavaScript is needed.
$MODULE::Header = qq~<script language="JavaScript" type="text/javascript">
/* Check the password and confirm password. */
function CheckPasswords()
{
    if(document.forms[0].password.value == document.forms[0].password2.value)
        return true;
    else{
        window.alert("Error: Your password and confirm password do not match!");
        return false;
    }
}
</script>~;

my $password = $HTTP_Args{'password'};

# Main function
sub Main
{
    if($password){
        # Verify their current password.
        my $currentpassword = $HTTP_Args{'currentpassword'};
        if(crypt($currentpassword, $passwd) ne $passwd){
            print "<font face=\"verdana, arial\" size=\"2\">Error: Incorrect password. Please try again.</font><br>\n";
            return;
        }

        # If they entered the same password as they're currently using, just abort.
        if(crypt($password, $passwd) eq $passwd){
            print "<font face=\"verdana, arial\" size=\"2\">New password same as old one.</font><br>\n";
            return;
        }

        # Call the update password routine for each password their account uses.
        UpdateASMPassword () if($HTTP_Args{'updateasm'}  eq 'yes');
        UpdateFTPPassword () if($HTTP_Args{'updateftp'}  eq 'yes');
        UpdateUNIXPassword() if($HTTP_Args{'updateunix'} eq 'yes');

        # Notify them that they need to log back in and log the change in the ASM log.
        print "<font face=\"verdana, arial\" size=\"2\">Password updated. You will need to login before you continue.</font><br>\n";
        API::LogAction("Password changed");
    }
    else{
        PrintUpdForm();
    }
}

# Print the update password form.
sub PrintUpdForm
{
    print "<form method=\"post\" action=\"$ENV{'SCRIPT_NAME'}\" onsubmit=\"return CheckPasswords();\">\n";
    print "<input type=\"hidden\" name=\"module\" value=\"passwd\">\n";
    print "<table border=\"0\" cellpadding=\"1\" cellspacing=\"0\" width=\"500\" align=\"center\">\n";
    print " <tr>\n";
    print "  <td colspan=\"2\" align=\"center\"><font face=\"verdana, arial\" size=\"2\"><b>Update Password</b></font></td>\n";
    print " </tr>\n";
    unless((!exists $modules{'ftp'}) && ($AUTH::IsUnixPassword)) {
        print " <tr>\n";
        print "  <td colspan=\"2\" align=\"center\">\n";
        print "   <table border=\"0\" cellpadding=\"1\" cellspacing=\"0\" width=\"300\" align=\"center\">\n";
        print "    <tr>\n";
        print "     <td><input type=\"checkbox\" name=\"updateasm\" value=\"yes\" checked></td>\n";
        print "     <td><font face=\"verdana, arial\" size=\"2\">Update ASM Password?</font></td>\n";
        print "    </tr>\n";
        if(exists $modules{'ftp'}) {
            print "    <tr>\n";
            print "     <td><input type=\"checkbox\" name=\"updateftp\" value=\"yes\" checked></td>\n";
            print "     <td><font face=\"verdana, arial\" size=\"2\">Update FTP Password?</font></td>\n";
            print "    </tr>\n";
        }
        if(!$AUTH::IsUnixPassword) {
            print "    <tr>\n";
            print "     <td><input type=\"checkbox\" name=\"updateunix\" value=\"yes\" checked></td>\n";
            print "     <td><font face=\"verdana, arial\" size=\"2\">Update UNIX Password?</font></td>\n";
            print "    </tr>\n";
        }
        print "   </table>\n";
        print "  </td>\n";
        print " </tr>\n";
    }
    print " <tr>\n";
    print "  <td><font face=\"verdana, arial\" size=\"2\">Current password:</font></td>\n";
    print "  <td><input type=\"password\" name=\"currentpassword\" value=\"\"></td>\n";
    print " </tr>\n";
    print " <tr>\n";
    print "  <td><font face=\"verdana, arial\" size=\"2\">New password:</font></td>\n";
    print "  <td><input type=\"password\" name=\"password\" value=\"\"></td>\n";
    print " </tr>\n";
    print " <tr>\n";
    print "  <td><font face=\"verdana, arial\" size=\"2\">Re-type password:</font></td>\n";
    print "  <td><input type=\"password\" name=\"password2\" value=\"\"></td>\n";
    print " </tr>\n";
    print " <tr>\n";
    print "  <td colspan=\"2\" align=\"center\"><input type=\"submit\" value=\"Submit\"></td>\n";
    print " </tr>\n";
    print "</table>\n";
    print "</form>\n";
}

# Update their ASM password.
sub UpdateASMPassword
{
    API::LoadAuthModule();
    API::ChangePassword($password);
}

# Update their FTP password.
sub UpdateFTPPassword
{
    if(exists $modules{'ftp'})
    {
        require "$BaseDir/modules/$modules{'ftp'}[0]";
        GetFTPAccounts();
        $accounts{$AUTH::User}{'passwd'} = crypt($password, API::RandomSalt());
        UpdateAuthFile();
    }
}

# Update their UNIX password.
sub UpdateUNIXPassword
{
    if(!$AUTH::IsUnixPassword) {
        system("/usr/sbin/usermod", "-p", crypt($password, API::RandomSalt()), $AUTH::User);
    }
}

1;
