/* 
 * Account Services Manager - Deluser
 *     Copyright (C) 2001 Brandon Ramirez. All rights reserved.
 *
 * For copying information, please see the file docs/licsence.txt
 */

#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <dirent.h>
#include <string.h>

#include "config.h"

#define VERSION "2.0"

//
// Global variables
//
int len;
char *username;

//
// Give the user a little info on how to run this program.
//
static void Usage(char *ProgramName)
{
    fprintf(stderr, "Account Services Manager - Deluser version %s\n", VERSION);
    fprintf(stderr, "Usage: %s <username>\n", ProgramName);
    exit(1);
}

//
// Verify that this user is allowed to run this program.
//
static void CheckUser()
{
    unsigned int uid, gid;

    uid = getuid();
    gid = getgid();

    if(uid)
    {
        fprintf(stderr, "Security Error: You are not authorized to run this program.\n");
        exit(2);
    }
}

//
// Delete the user's account.
//
static void DeleteAccount()
{
    chdir(BASE_DIR);
    chdir("users");

    if(unlink(username) == 0)
        printf("User %s successfully deleted\n", username);
    else
    {
        fprintf(stderr, "Unable to delete user %s\n", username);
        exit(3);
    }
}

//
// Erase all user sessions.
//
static void DeleteSessions()
{
    char *buffer;
    DIR *dir;
    dirent *file;
    int sessions, len;

    chdir(BASE_DIR);
    chdir("lock");

    sessions  = 0;
    len       = strlen(username) + 1;
    buffer    = new char[len];
    dir       = opendir(".");
    while((file = readdir(dir)) != NULL)
    {
        sprintf(buffer, "%s.", username);
        if(strncmp(file->d_name, buffer, len) == 0)
        {
            unlink(file->d_name);
            sessions++;
        }
    }
    closedir(dir);
    delete buffer;

    if(sessions > 0)
        printf("%d session(s) were removed.\n", sessions);
}

int main(int argc, char *argv[])
{
    username = argv[1];

    if(argc != 2 || (strcmp(username, "--help") == 0))
        Usage(argv[0]);

    CheckUser();
    DeleteAccount();
    DeleteSessions();

    return(0);
}
